"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mediaQueryRegex = exports.sizes = exports.sizeNames = void 0;
exports.sizeNames = ['small', 'medium', 'large'];
exports.sizes = {
    small: {
        min: 320,
        default: 321,
        max: 640,
    },
    medium: {
        min: 641,
        default: 642,
        max: 991,
    },
    large: {
        min: 990,
        default: 991,
        max: 1200,
    },
    getWidthForSize(size) {
        return this[size].default;
    },
    getSizeForWidth(width) {
        for (const size of exports.sizeNames) {
            const value = this[size];
            if (width <= value.max) {
                return size;
            }
        }
        return 'large';
    },
};
exports.mediaQueryRegex = /@\s*?media\s*?\(\s*?max-width\s*?:\s*?(\d+)(px)\s*?\)\s*?/;
