"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.componentToAngular = void 0;
const component_1 = require("../../generators/angular/classic/component");
const component_2 = require("../../generators/angular/signals/component");
const types_1 = require("../../generators/angular/types");
const merge_options_1 = require("../../helpers/merge-options");
const componentToAngular = (userOptions = {}) => {
    return (args) => {
        const options = (0, merge_options_1.initializeOptions)({
            target: 'angular',
            component: args.component,
            defaults: types_1.DEFAULT_ANGULAR_OPTIONS,
            userOptions,
        });
        if (options.api === 'signals') {
            /*
             * Some features aren't available to reduce complexity for now:
             * - Spread props
             * - Dynamic components
             */
            return (0, component_2.componentToAngularSignals)(userOptions)(args);
        }
        return (0, component_1.componentToAngularClassic)(userOptions)(args);
    };
};
exports.componentToAngular = componentToAngular;
