"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tryFormat = void 0;
const standalone_1 = require("prettier/standalone");
const tryFormat = (str, parser) => {
    try {
        return (0, standalone_1.format)(str, {
            parser,
            plugins: [
                // To support running in browsers
                require('prettier/parser-typescript'),
                require('prettier/parser-postcss'),
                require('prettier/parser-html'),
                require('prettier/parser-babel'),
            ],
            htmlWhitespaceSensitivity: 'ignore',
        });
    }
    catch (err) {
        console.warn('Could not prettify', { string: str }, err);
    }
    return str;
};
exports.tryFormat = tryFormat;
