"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAngularStyles = void 0;
const format_1 = require("../../../generators/angular/helpers/format");
const index_1 = require("../../../generators/angular/helpers/index");
const indent_1 = require("../../../helpers/indent");
const collect_css_1 = require("../../../helpers/styles/collect-css");
const getAngularStyles = ({ json, options, }) => {
    (0, index_1.preprocessCssAsJson)(json);
    let css = (0, collect_css_1.collectCss)(json);
    if (options.prettier !== false) {
        css = (0, format_1.tryFormat)(css, 'css');
    }
    const hostDisplayCss = options.visuallyIgnoreHostElement ? ':host { display: contents; }' : '';
    return (0, indent_1.indent)(css.length ? [hostDisplayCss, css].join('\n') : hostDisplayCss, 8);
};
exports.getAngularStyles = getAngularStyles;
