"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseSelector = void 0;
const compiler_1 = require("@angular/compiler");
function parseSelector(selector) {
    const { element, classNames, attrs } = compiler_1.CssSelector.parse(selector)[0];
    const attributes = attrs.reduce((acc, attr, i) => {
        if (i % 2 === 0) {
            acc[attr] = attrs[i + 1];
        }
        return acc;
    }, {});
    return {
        element,
        classNames,
        attributes,
    };
}
exports.parseSelector = parseSelector;
