"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAngularCoreImportsAsString = void 0;
const getAngularCoreImportsAsString = ({ refs, output, input, model, onPush, effect, signal, computed, viewChild, viewContainerRef, templateRef, renderer, }) => {
    const angularCoreImports = {
        Component: true,
        viewChild: refs || viewChild,
        ElementRef: refs || viewChild,
        ViewContainerRef: viewContainerRef,
        TemplateRef: templateRef,
        Renderer2: !!renderer,
        model,
        output,
        input,
        effect,
        signal,
        computed,
        ChangeDetectionStrategy: onPush,
        InputSignal: input,
        ModelSignal: model,
    };
    return Object.entries(angularCoreImports)
        .map(([key, bool]) => (bool ? key : ''))
        .filter((key) => !!key)
        .join(', ');
};
exports.getAngularCoreImportsAsString = getAngularCoreImportsAsString;
