"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.contextToQwik = void 0;
const standalone_1 = require("prettier/standalone");
const contextToQwik = (options = {}) => ({ context }) => {
    let str = `
  import { createContextId } from '@builder.io/qwik';

  export default createContextId<any>("${context.name}")
  `;
    if (options.format !== false) {
        try {
            str = (0, standalone_1.format)(str, {
                parser: 'typescript',
                plugins: [
                    require('prettier/parser-typescript'), // To support running in browsers
                ],
            });
        }
        catch (err) {
            if (process.env.NODE_ENV !== 'test') {
                console.error('Format error for file:', str);
            }
            throw err;
        }
    }
    return str;
};
exports.contextToQwik = contextToQwik;
