"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.contextToRsc = void 0;
const get_state_object_string_1 = require("../../helpers/get-state-object-string");
const standalone_1 = require("prettier/standalone");
/**
 * React Server Components currently do not support context, so we use
 * plain objects and prop drilling instead.
 */
const contextToRsc = (options = {}) => ({ context }) => {
    let str = `
    export default ${(0, get_state_object_string_1.stringifyContextValue)(context.value)}
    `;
    if (options.format !== false) {
        try {
            str = (0, standalone_1.format)(str, {
                parser: 'typescript',
                plugins: [
                    require('prettier/parser-typescript'), // To support running in browsers
                ],
            });
        }
        catch (err) {
            if (process.env.NODE_ENV !== 'test') {
                console.error('Format error for file:', str);
            }
            throw err;
        }
    }
    return str;
};
exports.contextToRsc = contextToRsc;
