"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.minify = void 0;
function minify(messageParts, ...expressions) {
    let text = '';
    for (let i = 0; i < messageParts.length; i++) {
        const part = messageParts[i];
        text += part;
        if (i < expressions.length) {
            text += expressions[i];
        }
    }
    return text
        .replace('\n', ' ')
        .replace(/^\s+/, '')
        .replace(/\s+$/, '')
        .replace(/\s+/g, ' ')
        .replace(/\s?([,;\:\-\{\}\(\)\<\>])\s?/g, (_, match) => match);
}
exports.minify = minify;
