"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDefaultProps = void 0;
const getDefaultProps = (json) => {
    if (!json.defaultProps)
        return '';
    const defaultPropsString = Object.keys(json.defaultProps)
        .map((prop) => {
        var _a;
        const value = json.defaultProps.hasOwnProperty(prop)
            ? (_a = json.defaultProps[prop]) === null || _a === void 0 ? void 0 : _a.code
            : 'undefined';
        return `${prop}: ${value}`;
    })
        .join(',');
    if (defaultPropsString) {
        return `props = {${defaultPropsString}, ...props}`;
    }
    return '';
};
exports.getDefaultProps = getDefaultProps;
