"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCodeProcessorPlugins = void 0;
const class_components_1 = require("../../../helpers/class-components");
const process_code_1 = require("../../../helpers/plugins/process-code");
const getCodeProcessorPlugins = (json, options, processBindingOptions) => {
    return [
        ...(options.plugins || []),
        (0, process_code_1.CODE_PROCESSOR_PLUGIN)((codeType) => {
            switch (codeType) {
                case 'bindings':
                case 'properties':
                case 'hooks':
                case 'hooks-deps':
                case 'hooks-deps-array':
                case 'state':
                case 'context-set':
                case 'dynamic-jsx-elements':
                case 'types':
                    return (code) => (0, class_components_1.processClassComponentBinding)(json, code, processBindingOptions);
            }
        }),
    ];
};
exports.getCodeProcessorPlugins = getCodeProcessorPlugins;
