"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRefs = void 0;
const legacy_1 = __importDefault(require("neotraverse/legacy"));
const is_mitosis_node_1 = require("./is-mitosis-node");
const getRefs = (json, refKey = 'ref') => {
    const refs = new Set();
    (0, legacy_1.default)(json).forEach(function (item) {
        if ((0, is_mitosis_node_1.isMitosisNode)(item)) {
            const binding = item.bindings[refKey];
            if (binding && typeof binding.code === 'string') {
                refs.add(binding.code);
            }
        }
    });
    return refs;
};
exports.getRefs = getRefs;
