"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTypedFunction = void 0;
/**
 * Get functions with typescript typing
 */
const getTypedFunction = (code, typescript, typeParameter) => {
    if (!typeParameter || !typescript) {
        return code;
    }
    const firstParenthesisIndex = code.indexOf('{');
    // The function should have at least one {
    if (firstParenthesisIndex < 0) {
        return code;
    }
    const preType = code.slice(0, firstParenthesisIndex - 1);
    const postType = code.slice(firstParenthesisIndex, code.length);
    return [preType, ': ', `ReturnType<${typeParameter}>`, postType].join('');
};
exports.getTypedFunction = getTypedFunction;
