"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stripMetaProperties = void 0;
const legacy_1 = __importDefault(require("neotraverse/legacy"));
const is_mitosis_node_1 = require("./is-mitosis-node");
const stripMetaProperties = (json) => {
    (0, legacy_1.default)(json).forEach((item) => {
        if ((0, is_mitosis_node_1.isMitosisNode)(item)) {
            for (const property in item.properties) {
                if (property.startsWith('$')) {
                    delete item.properties[property];
                }
            }
            for (const property in item.bindings) {
                if (property.startsWith('$')) {
                    delete item.bindings[property];
                }
            }
        }
    });
    return json;
};
exports.stripMetaProperties = stripMetaProperties;
