"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.collectTypes = exports.isTypeOrInterface = exports.getPropsTypeRef = void 0;
const babel = __importStar(require("@babel/core"));
const generator_1 = __importDefault(require("@babel/generator"));
const { types } = babel;
const getPropsTypeRef = (node, context) => {
    var _a;
    const param = node.params[0];
    // TODO: component function params name must be props
    if (babel.types.isIdentifier(param) &&
        param.name === 'props' &&
        babel.types.isTSTypeAnnotation(param.typeAnnotation)) {
        const paramIdentifier = babel.types.variableDeclaration('let', [
            babel.types.variableDeclarator(param),
        ]);
        const generatedTypes = (0, generator_1.default)(paramIdentifier)
            .code.replace(/^let\sprops:\s+/, '')
            .replace(/;/g, '');
        if (generatedTypes.startsWith('{')) {
            const propsTypeRef = `${(_a = node.id) === null || _a === void 0 ? void 0 : _a.name}Props`;
            context.builder.component.types = [
                ...(context.builder.component.types || []),
                `export interface ${propsTypeRef} ${generatedTypes}`,
            ];
            return propsTypeRef;
        }
        return generatedTypes;
    }
    return undefined;
};
exports.getPropsTypeRef = getPropsTypeRef;
const isTypeImport = (node) => {
    var _a;
    return types.isImportDeclaration(node) &&
        node.importKind === 'type' &&
        // Babel adds an implicit JSX type import that we don't want
        ((_a = node.specifiers[0]) === null || _a === void 0 ? void 0 : _a.local.name) !== 'JSX';
};
const isTypeOrInterface = (node) => types.isTSTypeAliasDeclaration(node) ||
    types.isTSInterfaceDeclaration(node) ||
    (types.isExportNamedDeclaration(node) && types.isTSTypeAliasDeclaration(node.declaration)) ||
    (types.isExportNamedDeclaration(node) && types.isTSInterfaceDeclaration(node.declaration));
exports.isTypeOrInterface = isTypeOrInterface;
const getTypesFromNode = (node, context) => {
    const typeStr = (0, generator_1.default)(node).code;
    const { types = [] } = context.builder.component;
    types.push(typeStr);
    context.builder.component.types = types.filter(Boolean);
};
const collectTypes = (path, context) => {
    const { node } = path;
    getTypesFromNode(node, context);
    path.remove();
};
exports.collectTypes = collectTypes;
