"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.undoPropsDestructure = void 0;
const babel = __importStar(require("@babel/core"));
const { types } = babel;
function undoPropsDestructure(path) {
    const { node } = path;
    if (node.params.length && types.isObjectPattern(node.params[0])) {
        const param = node.params[0];
        const propsMap = param.properties.reduce((pre, cur) => {
            if (types.isObjectProperty(cur) &&
                types.isIdentifier(cur.key) &&
                types.isIdentifier(cur.value)) {
                pre[cur.value.name] = `props.${cur.key.name}`;
                return pre;
            }
            return pre;
        }, {});
        if (param.typeAnnotation) {
            node.params = [
                {
                    ...babel.types.identifier('props'),
                    typeAnnotation: param.typeAnnotation,
                },
            ];
            path.replaceWith(node);
        }
        path.traverse({
            JSXExpressionContainer(path) {
                const { node } = path;
                if (types.isIdentifier(node.expression)) {
                    const { name } = node.expression;
                    if (propsMap[name]) {
                        path.replaceWith(babel.types.jsxExpressionContainer(babel.types.identifier(propsMap[name])));
                    }
                }
            },
        });
    }
}
exports.undoPropsDestructure = undoPropsDestructure;
